unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, frm2, inher;

type
  TFormMain = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    DialogBox: TFormDialog;
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}

procedure TFormMain.Button1Click(Sender: TObject);
begin
  // create only one instance
  if not Assigned (DialogBox) then
    DialogBox := TFormDialog.Create (Edit1.Text);
  DialogBox.Show;
end;

procedure TFormMain.Button2Click(Sender: TObject);
begin
  with TFormInherit.Create (Edit1.Text) do
    Show;
end;

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Button1 := FindComponent ('Button1') as TButton;
  Edit1 := FindComponent ('Edit1') as TEdit;
  Button2 := FindComponent ('Button2') as TButton;
end;

procedure TFormMain.Button3Click(Sender: TObject);
begin
  if Assigned (DialogBox) then
    ShowMessage (DialogBox [0]);
end;

initialization
  RegisterClasses ([
    TButton,
    TEdit, TListBox]);
end.
