unit inher;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  frm2, StdCtrls;

type
  TFormInherit = class(TFormDialog)
    procedure ButtonClearClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    ButtonClear: TButton;
  protected
    procedure SetText(const Value: String); override;
  end;

implementation

{$R *.DFM}

procedure TFormInherit.ButtonClearClick(Sender: TObject);
begin
  inherited;
  // Edit1.Text := '';  // illegal
  // SetText ('');
  Text := '';
end;

procedure TFormInherit.FormCreate(Sender: TObject);
begin
  inherited;
  ButtonClear := FindComponent ('ButtonClear') as TButton;
end;

procedure TFormInherit.SetText(const Value: String);
begin
  inherited SetText (Value);
  if Value = '' then
    ButtonClear.Enabled := False;
end;

initialization
  RegisterClasses ([
    TButton]);
end.
